<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<title>/vagrant/python/networking/client-server/multithread_server.py.html</title>
<meta name="Generator" content="Vim/8.1">
<meta name="plugin-version" content="vim8.1_v1">
<meta name="syntax" content="python">
<meta name="settings" content="use_css,pre_wrap,no_foldcolumn,prevent_copy=">
<meta name="colorscheme" content="none">
<style type="text/css">
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #ffffff; background-color: #000000; }
body { font-family: monospace; color: #ffffff; background-color: #000000; }
* { font-size: 1em; }
.PreProc { color: #5fd7ff; }
.Comment { color: #00ffff; }
.Constant { color: #ff40ff; }
.Identifier { color: #00ffff; font-weight: bold; }
.Statement { color: #ffff00; }
-->
</style>
</head>
<body>
<pre id='vimCodeElement'>
<span class="Comment">#!/usr/bin/env python3</span>
<span class="Comment">#</span>
<span class="Comment"># Tomado de: </span>
<span class="Comment"># <a href="https://stackoverflow.com/questions/23828264/how-to-make-a-simple-multithreaded-socket-server-in-python-that-remembers-client">https://stackoverflow.com/questions/23828264/how-to-make-a-simple-multithreaded-socket-server-in-python-that-remembers-client</a></span>
<span class="Comment">#</span>
<span class="Comment"># Author: John Sanabria - john.sanabria@correounivalle.edu.co</span>
<span class="Comment"># Date: 2022-13-15</span>
<span class="Comment">#</span>
<span class="Comment"># 2022-03-15:</span>
<span class="Comment">#   Se modifico el codigo original para que este servidor pudiera interoperar </span>
<span class="Comment">#   con el cliente cuyo codigo esta en este directorio en el archivo </span>
<span class="Comment">#   'client.py'</span>
<span class="Comment">#</span>

<span class="PreProc">import</span> socket
<span class="PreProc">import</span> threading

<span class="Statement">class</span> <span class="Identifier">ThreadedServer</span>(<span class="Identifier">object</span>):
    <span class="Statement">def</span> <span class="Identifier">__init__</span>(self, host, port):
        self.host = host
        self.port = port
        self.sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, <span class="Constant">1</span>)
        self.sock.bind((self.host, self.port))

    <span class="Statement">def</span> <span class="Identifier">listen</span>(self):
        self.sock.listen(<span class="Constant">5</span>)
        cont = <span class="Constant">0</span>
        <span class="Statement">while</span> <span class="Identifier">True</span>:
            client, address = self.sock.accept()
            cont = cont + <span class="Constant">1</span>
            threading.Thread(target = self.listenToClient,
                             args = (client,address, cont)).start()

    <span class="Statement">def</span> <span class="Identifier">listenToClient</span>(self, client, address, cont):
        <span class="Comment">#sending a TCP message to the client in the form of bytes </span>
        client.send(<span class="Identifier">bytes</span>(<span class="Constant">'</span><span class="Constant">Hello! Welcome to Pythongeeks</span><span class="Constant">'</span>,<span class="Constant">'</span><span class="Constant">utf-8</span><span class="Constant">'</span>))
        <span class="Comment">#getting the TCP message from the client and decoding it </span>
        c_msg=client.recv(<span class="Constant">1024</span>).decode()
        <span class="Statement">if</span> c_msg != <span class="Constant">&quot;</span><span class="Constant">Happy to connect with you!</span><span class="Constant">&quot;</span>:
           <span class="Identifier">print</span>(<span class="Constant">&quot;</span><span class="Constant">Error receiving string from client</span><span class="Constant">&quot;</span>)
           <span class="Comment">#printing the message</span>
           <span class="Identifier">print</span>(f<span class="Constant">'</span><span class="Constant">[{cont}] The message from the client {client} is {c_msg}</span><span class="Constant">'</span>)
           sys.exit(<span class="Constant">1</span>)
        <span class="Statement">else</span>:
           <span class="Identifier">print</span>(f<span class="Constant">'</span><span class="Constant">[{cont}]</span><span class="Constant">'</span>)
        <span class="Comment">#This stops the connection</span>
        client.close()

<span class="Statement">if</span> __name__ == <span class="Constant">&quot;</span><span class="Constant">__main__</span><span class="Constant">&quot;</span>:
    port_num = <span class="Constant">9999</span>
    ThreadedServer(<span class="Constant">''</span>,port_num).listen()
</pre>
</body>
</html>
<!-- vim: set foldmethod=manual : -->
